function complyadm::save_pe_certs(
  Optional[String] $tls_crt = '',
  Optional[String] $tls_key = '',
  Optional[String] $ca_crt = '',
  Optional[String] $hiera_data_file_path = 'data/common.yaml',
  Optional[String] $pkcs7_public_key_path = 'keys/public_key.pkcs7.pem',
) >> Boolean {
  $tls_crt_updated = if $tls_crt != '' {
    complyadm::save_yaml_key_value('tls_crt', regsubst(complyadm::encrypt(Sensitive($tls_crt), $pkcs7_public_key_path), '\n', ' ', 'MG'), $hiera_data_file_path)
  } else {
    false
  }
  $tls_key_updated = if $tls_key != '' {
    complyadm::save_yaml_key_value('tls_key', regsubst(complyadm::encrypt(Sensitive($tls_key), $pkcs7_public_key_path), '\n', ' ', 'MG'), $hiera_data_file_path)
  } else {
    false
  }
  $ca_crt_updated = if $ca_crt != '' {
    complyadm::save_yaml_key_value('ca_crt', regsubst(complyadm::encrypt(Sensitive($ca_crt), $pkcs7_public_key_path), '\n', ' ', 'MG'), $hiera_data_file_path)
  } else {
    false
  }
  # return true if any entry updated
  true in [$tls_crt_updated, $tls_key_updated, $ca_crt_updated]
}
