require 'yaml'
require 'fileutils'

# Gets a single entry from the stored yaml
Puppet::Functions.create_function(:'complyadm::get_yaml_key_value') do
  # @param data A hash to write as yaml
  # @return value if exists, else nil
  dispatch :get_yaml_key_value do
    param 'String', :key
    param 'String', :relative_file_path
    return_type 'String'
  end

  def get_yaml_key_value(key, relative_file_path)
    boltdir = call_function('complyadm::bolt_project_dir')
    abs_file_path = File.expand_path(relative_file_path, boltdir)
    value = ''
    if File.file?(abs_file_path)
      data = YAML.load_file abs_file_path
      if data['complyadm::config'].key?(key)
          value=data['complyadm::config'][key]
      end
    end
    value
  end
end
