require 'yaml'
require 'fileutils'

# Takes a hash object, calls .to_yaml and saves it to disk
Puppet::Functions.create_function(:'complyadm::save_yaml_key_value') do
  # @param data A hash to write as yaml
  # @param relative_file_path path relative to the bolt project
  # @return true
  dispatch :save_yaml_key_value do
    param 'String', :key
    param 'String', :value
    param 'String', :relative_file_path
    return_type 'Boolean'
  end

  def save_yaml_key_value(key, value, relative_file_path)
    boltdir = call_function('complyadm::bolt_project_dir')
    abs_file_path = File.expand_path(relative_file_path, boltdir)
    data = YAML.load_file abs_file_path
    data['complyadm::config'][key] = value
    File.open(abs_file_path, 'w') do |file|
      file.write data.to_yaml
    end
    true
  end
end
