# @summary installs and configures the main backend component
#
# @param config subset of Complyadm::Config specific to assessor_init
class complyadm::component::ui_assessor_init (
  Complyadm::Config::Comply_ui_assessor_init $config,
) {
  $container = $config['container']

  complyadm::runtime::volume { 'assessors':
    ensure  => 'present',
    runtime => $container['runtime'],
  }

  $init_env = "/etc/puppetlabs/comply/${container['name']}.env"
  file { $init_env:
    ensure    => file,
    owner     => 'root',
    group     => 'root',
    seltype   => 'container_file_t',
    show_diff => false,
    content   => epp('complyadm/comply_env.epp', { env_vars => $container['env_vars'] }),
    notify    => Complyadm::Runtime::Run[$container['name']],
  }

  complyadm::runtime::run { $container['name']:
    runtime                  => $container['runtime'],
    install_runtime          => $container['install_runtime'],
    image                    => $container['image'],
    net                      => $container['net'],
    pull_on_start            => false,
    env_file                 => [$init_env],
    require                  => [File[$init_env]],
    volumes                  => ['assessors:/Assessor-CLI'],
    after                    => $container['after'],
    extra_parameters         => $container['extra_parameters'],
    extra_systemd_parameters => $container['extra_systemd_parameters'],
  }
}
