# @api private
#
# @summary Generates a hiera data file for use when calling complyadm::install
#
# @param [String] path Path to save dev.yaml file
# @param [String] features Feature flags
# @param [String] version Version of the Comply images to install
plan complyadm::generate_dev(
  String $path = 'data',
  String $features = 'nolicense,cem_up_sell',
  String $version = 'master'
) {
  complyadm::save_yaml_file(
    {
      'complyadm::dev' => {
        features => $features.split(','),
        version => $version,
      },
    },
  "${path}/dev.yaml")
}
