# @api private
#
# Ensures that this version of Comply's application images are on all infra targets.
#
# @param config Complyadm::Config config object from hiera
#
# @return This plan does not return anything
plan complyadm::install::download_images(
  Complyadm::Config $config,
) {
  $runtime = $config['runtime']

  $config['roles'].each |$role, $role_info| {
    $targets_by_role = $role_info['targets']
    $role_info['services'].each |$name, $service| {
      $image_name = $service['container']['image']

      out::message("Pulling Image '${image_name}'...")
      run_command(
        "${runtime} pull ${image_name}",
        $targets_by_role,
        '_run_as' => 'root'
      )
    }
  }
}
