# @api private
#
# Prints summary information and next steps post-install
#
# @param config Complyadm::Config object with all config options
#
# @return Does not return anything
plan complyadm::install::overview(
  Complyadm::Config $config
) {
  $browser_certs_dir = file::join(complyadm::bolt_project_files_dir(), 'comply', 'browser_certs')
  $application_url = $config['resolvable_hostname']

  $role_summary = $config['roles'].reduce('') |$memo, $role| {
    "${memo}${role[0]}:\n  ${role[1]['targets'].join(', ')}\n"
  }
# lint:ignore:strict_indent
  $next_steps = @("NEXTSTEPS"/L)
     
=========================================== Next Steps ============================================

  1. You can now access the Security Compliance Management application at:
  https://${application_url}

  2. To create a backup, run the complyadm::backup plan.

  3. To experience the full value of Puppet Enterprise, install the Puppet Enterprise Suite:
  https://www.puppet.com/pe

  See https://www.puppet.com/docs/comply/3.x/comply.html for more information.

===================================================================================================

  | NEXTSTEPS
# lint:endignore
  without_default_logging () || {
    out::message("\nSecurity Compliance Management successfully installed to:")
    out::message($role_summary)
    out::message($next_steps)
  }
}
