# This plan installs and configures the backend role.
#
# @api private
# @param config The Comply config
plan complyadm::install::roles::backend(
  Complyadm::Config $config,
) {
  $apply_options = {
    '_run_as' => 'root',
    '_description' => 'install and configure application components for role: Backend',
  }

  apply($config['roles']['backend']['targets'], $apply_options) {
    class { 'complyadm':
      runtime => $config['runtime'],
      ca_crt  => $config['ca_crt'],
    }

    class { 'complyadm::component::redis':
      config => $config['roles']['backend']['services']['comply_redis'],
    }

    class { 'complyadm::component::graphql':
      config => $config['roles']['backend']['services']['comply_graphql'],
    }

    class { 'complyadm::component::scarpy':
      config => $config['roles']['backend']['services']['comply_scarpy'],
    }

    class { 'complyadm::component::identity':
      config => $config['roles']['backend']['services']['comply_identity'],
    }

    class { 'complyadm::component::gatekeeper':
      config => $config['roles']['backend']['services']['comply_gatekeeper'],
    }

    class { 'complyadm::component::frontdoor':
      config => $config['roles']['backend']['services']['comply_frontdoor'],
    }

    class { 'complyadm::component::mtls_proxy':
      config => $config['roles']['backend']['services']['comply_mtls_proxy'],
    }

    class { 'complyadm::component::graphql_init':
      config => $config['roles']['backend']['services']['comply_graphql_init'],
    }

    class { 'complyadm::component::scarpy_assessor_init':
      config => $config['roles']['backend']['services']['comply_scarpy_assessor_init'],
    }

    class { 'complyadm::component::scarpy_init':
      config => $config['roles']['backend']['services']['comply_scarpy_init'],
    }

    class { 'complyadm::component::assessor_upgrade':
      config => $config['roles']['backend']['services']['comply_assessor_upgrade'],
    }
  }
}
