# @api private
#
# Calls the manifests needed to install and configure the database role
#
# @param config Complyadm::Config object with all config options
#
# @return Does not return anything
plan complyadm::install::roles::database(
  Complyadm::Config $config,
) {
  $apply_options = {
    '_run_as' => 'root',
    '_description' => 'install and configure application components for role: Database',
  }

  apply($config['roles']['database']['targets'], $apply_options) {
    class { 'complyadm':
      runtime => $config['runtime'],
    }

    class { 'complyadm::component::postgres':
      config => $config['roles']['database']['services']['comply_postgres'],
    }
  }
}
