# @api private
#
# Calls the manifests needed to install and configure the UI role
#
# @param config Complyadm::Config object with all config options
#
# @return Does not return anything
plan complyadm::install::roles::ui(
  Complyadm::Config $config,
) {
  $apply_options = {
    '_run_as' => 'root',
    '_description' => 'install and configure application components for role: UI ',
  }

  apply($config['roles']['ui']['targets'], $apply_options) {
    class { 'complyadm':
      runtime => $config['runtime'],
    }

    class { 'complyadm::component::ui_assessor_init':
      config => $config['roles']['ui']['services']['comply_ui_assessor_init'],
    }

    class { 'complyadm::component::ui':
      config => $config['roles']['ui']['services']['comply_ui'],
    }
  }
}
