# @api private
#
# Waits until we get a 200 healthy status response back from the
# Comply api endpoint.
#
# @param config Complyadm::Config config object
#
# @return This plan does not return anything
plan complyadm::install::wait_for_services(
  Complyadm::Config $config = complyadm::config()
) {
  $url = $config['resolvable_hostname']
  $is_healthy = complyadm::status_check($url)
  if !$is_healthy {
    fail_plan('UI did not come up within expected time frame', 'comply/error')
  }
}
