# @api private
#
# Validates that the provided infrastructure setup is supported
#
# @param config Complyadm::Config config object from hiera
#
# @return Hash containing failed and passed arrays
plan complyadm::preflight::architecture (
  Complyadm::Config $config = complyadm::config()
) {
  $hosts = $config['all_targets']

  if ($hosts.length == 1) {
    $result = {
      'passed' => ['Infrastructure setup is supported'],
      'failed' => [],
    }
  } else {
    $result = {
      'passed' => [],
      'failed' => ["Expected all target hosts to be the same but got ${hosts.join(', ')}"],
    }
  }

  return $result
}
