#!/opt/puppetlabs/puppet/bin/ruby
require 'json'
require 'open3'
# This task runs the scarp migrate command to populate the pepper and the salt.

# @param [String] salt The salt for API tokens.
# @param [String] pepper The pepper for PE details.
# @param [String] runtime Used to execute the psql command from within the container
# @param [String] task_dir The absolute path to the directory of the running Bolt task.
def migrate_secrets(runtime, salt, pepper, _task_dir)
  command = "#{runtime} exec -i comply_scarpy scarp migrate-secrets -s #{salt} -p #{pepper}"
  combined_output = ''
  status = ''
  combined_output, status = Open3.capture2e(command)
  { 'output': combined_output, 'successful': status.success? }
end

# Pull in input
params = JSON.parse(STDIN.read)

output = migrate_secrets(params['runtime'], params['salt'], params['pepper'],  params['_installdir'])

puts output.to_json