require "test/unit"
require 'ruby_expect'
 
class BackupRestore< Test::Unit::TestCase
 
  def test_backup_restore
    results = { "backup" => "unknown",
                "restore" => "unknown",
                "list" => "unknown",
                "backup_name" => ""
    }

    exp = RubyExpect::Expect.spawn('cd .. & bundle exec bolt plan run complyadm::backup', :debug => true)
    exp.timeout=(180)
    exp.procedure do
      each do
        expect /comply-backup.*zip/ do
          results["backup"] = true
          results["backup_name"] = exp.last_match
        end
      end
    end
    exp.soft_close()

    exp = RubyExpect::Expect.spawn('cd .. & bundle exec bolt plan run complyadm::list_backups', :debug => true)
    exp.timeout=(180)
    exp.procedure do
      each do
        expect "#{results["backup_name"]}" do
          results["list"] = true
        end
      end
    end
    exp.soft_close()

    exp = RubyExpect::Expect.spawn("cd .. & bundle exec bolt plan run complyadm::restore backup=#{results["backup_name"]}", :debug => true)
    exp.timeout=(300)
    exp.procedure do
      each do
        expect /Restore complete/ do
          results["restore"] = true
          results["backup_name"] = exp.last_match
        end
      end
    end
    exp.soft_close()

    #Verify the Results
    assert_equal(true,results['backup'])
    assert_equal(true,results['list'])
    assert_equal(true,results['restore'])
  end 
end
