require "test/unit"
require 'ruby_expect'
 
class TestConfigure < Test::Unit::TestCase
 
  def test_configure
    results = { "data_retention" => "unknown",
                "fact_update" => "unknown",
                "assessor_update" => "unknown",
                "assessor_version" => "unknown",
                "log_level" => "unknown",
                "mtls" => "unknown",
                "tls" => "unknown"}

    exp = RubyExpect::Expect.spawn('cd .. & bundle exec bolt plan run complyadm::configure', :debug => true)
    exp.timeout=(10)
    exp.procedure do
      each do
        expect /Data retention period.*:/ do
          send '2'
        end
      end
      each do
        expect /Fact update check interval.*:/ do
          results['data_retention'] = true
          send '1'
        end
      end
      each do
        expect /Assessor update check interval.*:/ do
          results['fact_update'] = true
          send '1'
        end
      end
      each do
        expect /User assessor version.*:/ do
          results['assessor_update'] = true
          send '1'
        end
      end
      each do
        expect /Log level.*:/ do
          results['assessor_version'] = true
          send '1'
        end
      end
      each do
        expect /Would you like to configure mTLS?.*:/ do
          results['log_level'] = true
          send 'n'
        end
      end
      each do
        expect /Would you like to configure TLS?.*:/ do
          results['mtls'] = true
          send 'n'
        end
      end
      each do
        expect /Application Updated, Restart Services?.*:/ do
          results['tls'] = true
          send 'n'
        end
      end
    end

    exp.soft_close()
    
    #Verify the Results
    assert_equal(true,results['data_retention'])
    assert_equal(true,results['fact_update'])
    assert_equal(true,results['assessor_update'])
    assert_equal(true,results['assessor_version'])
    assert_equal(true,results['log_level'])
    assert_equal(true,results['mtls'])
    assert_equal(true,results['tls'])
  
  end 
end
