require "test/unit"
require 'ruby_expect'
 
class Ctl< Test::Unit::TestCase
 
  def test_ctl
    results = { "stop" => "unknown",
                "status" => "unknown"}

    exp = RubyExpect::Expect.spawn('cd .. & bundle exec bolt plan run complyadm::ctl service=comply_ui action=stop', :debug => true)
    exp.timeout=(60)
    exp.procedure do
      each do
        expect /Plan completed successfully/ do
          results["stop"] = true
        end
      end
    end
    exp.soft_close()
      
    exp = RubyExpect::Expect.spawn('cd .. & bundle exec bolt plan run complyadm::ctl service=comply_ui action=status', :debug => true)
    exp.timeout=(60)
    exp.procedure do
      each do
        expect /Stopped Daemon for comply_ui/ do
          results["status"] = true
        end
      end
    end
    exp.soft_close()  
      
    #Verify the Results
    assert_equal(true,results['stop'])
    assert_equal(true,results['status'])
  end 
end
