# Comply configuration that customers can change
type Complyadm::Hiera_config = Struct[{
    targets             => Struct[{
        backend  => Array[String[1]],
        database => Array[String[1]],
        ui       => Array[String[1]],
    }],
    admin_db_password    => String[1],
    comply_db_password   => String[1],
    comply_db_username   => Optional[String[1]],
    identity_db_password => String[1],
    identity_db_username => Optional[String[1]],
    resolvable_hostname  => String[1],
    runtime              => Optional[Complyadm::Runtime],
    install_runtime      => Optional[Boolean],
    secret_key           => String[16],
    backup_dir           => Optional[String[1]],
    containers           => Optional[Struct[{
          postgres => Optional[Struct[{
                log_level        => Optional[Enum['INFO', 'NOTICE', 'WARNING', 'ERROR']],
                max_log_size_mb  => Optional[Integer[1]],
                keep_log_files   => Optional[Integer[0]],
                extra_parameters => Optional[String[1]],
          }]],
    }]],

    # browser tls config
    ssl_cert_chain                    => Optional[String[1]],
    ssl_crl                           => Optional[String[1]],
    ssl_private_key                   => Optional[String[1]],

    # identity/gatekeeper secrets
    identity_account                  => String[1],
    identity_account_console          => String[1],
    identity_admin_cli                => String[1],
    identity_broker                   => String[1],
    identity_realm_management         => String[1],
    identity_security_admin_console   => String[1],
    client_secret                     => String[1],
    cookie_secret                     => String[1],
    db_encryption_key                 => String[1],
    identity_admin_user               => String[1],
    identity_admin_password           => String[1],

    # redis passwords
    redis_password                    => String[1],

    assessor_update_check_interval    => String[1],
    data_retention_period             => String[1],
    fact_update_check_interval        => String[1],

    # assessor info
    user_assessor_version             => String[1],

    hasura_admin_secret               => String[1],

    pe                                => String,

    log_level                         => Enum['info', 'warn', 'debug'],

    ca_crt                            => String,
    tls_crt                           => String,
    tls_key                           => String,

    cert_chain                        => String,
    private_key                       => String,
    crl                               => String,
}]
